#include "common.h"
#include "util.h"
#include "dump_ast.h"

#include <boost/spirit/iterator/position_iterator.hpp>

string node_id2str(const node& node) {
    switch (node.value.id().to_long()) {
#define DEF_RULE(name) \
case Grammar::name##ID: return __STRING(name);
#include "rules.tab"
#undef DEF_RULE
    }
    error("unkown ID, shouldn't happen");
}

static void dump_ast_impl(const node& node, int depth) {
    for (int i = 0; i < depth; i++) {
        LOG << "  ";
    }
    LOG << node_id2str(node)
        << "(" << string(node.value.begin(), node.value.end()) << ")\n";

    for_each(node.children.begin(), node.children.end(),
             bind(dump_ast_impl, _1, depth+1));
}

void dump_ast(const parser_info& info) {
    dump_ast_impl(info.trees[0], 0);
}
