#include "elf_os.h"
#include "util.h"

#include <string>

#include <elf.h>

class ELFOSInfoImpl : public ELFOSInfo {
public:
    virtual char os_abi() { return os_abi_; }
    virtual const char* interp() { return interp_; }
    virtual const char* libc() { return libc_; }
    virtual const char* libc2() { return libc2_; }

private:
    char os_abi_;
    const char* interp_;
    const char* libc_;
    const char* libc2_;

    friend class ELFOSInfo;
};

ELFOSInfo* ELFOSInfo::get(const char* os_name) {
    ELFOSInfoImpl* info = new ELFOSInfoImpl;
#define DEF_OS(os, abi, interp, libc, libc2) \
if (!strcmp(os_name, __STRING(os))) { \
  info->os_abi_ = abi;                \
  info->interp_ = interp;             \
  info->libc_ = libc;                 \
  info->libc2_ = libc2;               \
  return info;                        \
}
#include "elf_os.tab"
#undef DEF_OS
    delete info;
    error(std::string(os_name) + ": unknown ELF OS type.");
}
