#ifndef PARSER_H_
#define PARSER_H_

#include <boost/spirit/iterator/position_iterator_fwd.hpp>
#include <boost/spirit/tree/ast.hpp>

typedef boost::spirit::position_iterator<char const*> parser_iterator;
typedef boost::spirit::tree_node<
    boost::spirit::node_val_data<parser_iterator> > node;
typedef boost::spirit::tree_parse_info<parser_iterator> parser_info;

struct Grammar {
    enum ID {
#define DEF_RULE(name) name##ID,
#include "rules.tab"
#undef DEF_RULE
    };
};

parser_info parse_program(const char* program);

#endif
