#define _GNU_SOURCE

#include "shi.h"
#include "preprocess.h"
#include "util.h"

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

static int result = -1;

void set_result(int x) {
    result = x;
}

void check(int x) {
    if (result != x) {
        printf("Expected: %d\nActual: %d\n", x, result);
        assert(result == x);
    }
}

extern void* (*shi_dlsym)(void* handle, const char* sym);

void* hooked_dlsym(void* handle, const char* sym) {
    if (!strcmp(sym, "check")) {
        return &check;
    }
    if (!strcmp(sym, "set_result")) {
        return &set_result;
    }
    return dlsym(RTLD_DEFAULT, sym);
}

int main(int argc, char* argv[]) {
    shi_dlsym = &hooked_dlsym;

    execute_program("set_result(42)\n");
    assert(result == 42);
    execute_program("set_result(42+2)\n");
    assert(result == 44);
    execute_program("set_result(42*2)\n");
    assert(result == 84);
    execute_program("set_result(2-42)\n");
    assert(result == -40);
    execute_program("set_result(42/2)\n");
    assert(result == 21);
    execute_program("set_result(42%33)\n");
    assert(result == 9);
    execute_program("set_result((42+3)%33)\n");
    assert(result == 12);

    execute_program(preprocess(read_file("test.shi")));

    puts("SUCCESS!");

    return 0;
}
