#include "preprocess.h"
#include "util.h"

#include <iostream>
#include <string>

using namespace std;

char* read_file(const char* filename) {
    FILE* fp = fopen(filename, "r");
    if (!fp) {
        printf("cannot open %s\n", filename);
        exit(1);
    }
    fseek(fp, 0, SEEK_END);
    int size = ftell(fp);
    fseek(fp, 0, SEEK_SET);
    char* buf = (char*)malloc(size+2);
    fread(buf, 1, size, fp);
    buf[size] = '\0';
    return buf;
}

void error(const char* msg) {
    cout << msg << endl;
    exit(1);
}

void error(const std::string& msg) {
    error(msg.c_str());
}

string read_file_with_preprocess(const char* filename) {
    char* buf = preprocess(read_file(filename));
    string r(buf);
    free(buf);
    return r;
}
